#include <iostream>
#include <chrono>
#include <ctime>
#include <thread>
#include <unistd.h>
#include <omp.h>

// Avoid cache coherence at any cost!

int main(int argc, char *argv[]) {
	long seq = 0;				// this should be print out sequentially
	int a[100000];

	auto c_start = std::clock();

	#pragma omp parallel num_threads(4)

	for (int i = 0; i < 100000; i++){
		int ID = omp_get_thread_num();
		for (int j = 0; j < 25000; j++){
			a[4*j + ID] = 1;
		}
	}

	auto c_end = std::clock();

	std::cout << "CPU clock time: " << 1000.0 * (c_end - c_start) / CLOCKS_PER_SEC << " ms" << std::endl;

}